GZIP(1)

NAZWA
gzip, gunzip, zcat - kompresuje i dekompresuje pliki

SKŁADNIA
gzip [-acdfhklLnNrtvV19] [-S rozszerzenie] [nazwa ...]
gunzip [-acfhklLnNrtvV] [-S rozszerzenie] [nazwa ... ]
zcat [-fhLV] [nazwa ...]

OPIS
Polecenie gzip redukuje rozmiar podanych plików używając algorytmu Lempel-Ziv (LZ77). Zawsze, jeżeli jest to możliwe, do nazwy pliku dodawane jest rozszerzenie .gz, przy zachowaniu informacji o właścicielu pliku, trybie dostępu, oraz czasie dostępu i modyfikacji (domyślnym rozszerzeniem nazwy pliku jest .z dla MSDOS, OS/2 FAT, Windows NT FAT i Atari). Jeżeli nie podano nazwy żadnego pliku, lub podano nazwę „-”, dane do kompresji pobierane są ze standardowego wejścia, a po skompresowaniu zapisywane na standardowe wyjście. Polecenie gzip kompresuje jedynie zwykłe pliki. W szczególności ignoruje dowiązania symboliczne.

Jeżeli nazwa skompresowanego pliku jest za długa dla systemu plików, gzip obcina ją. Polecenie gzip usiłuje obcinać jedynie części nazw plików dłuższe niż 3 znaki (część nazwy pliku znajduje się pomiędzy kropkami). Jeżeli nazwa składa się tyko z krótkich części, obcinane są najdłuższe z nich. Na przykład, jeżeli długość nazwy plików jest ograniczona do 14 znaków, gzip.msdos.exe jest kompresowane do gzi.msd.exe.gz. Jeżeli w systemie plików nie ma ograniczenia długości nazwy pliku, nazwa nie jest obcinana.

Domyślnie gzip zachowuje oryginalną nazwę pliku oraz czas modyfikacji i dostępu wewnątrz skompresowanego pliku. Jest ona używana podczas dekompresji z opcją -N. Jest to użytecznie, gdy nazwa skompresowanego pliku została obcięta lub czas modyfikacji nie został zachowany po transferze pliku.

Skompresowane pliki mogą być odtworzone do pierwotnej postaci przy użyciu poleceń gzip -d, gunzip lub zcat. Jeżeli oryginalna nazwa pliku zachowana wewnątrz pliku skompresowanego nie może być odtworzona w danym systemie plików, na podstawie oryginalnej nazwy tworzona jest nowa.

gunzip uruchamiany jest z listą plików w linii poleceń. Następnie każdy plik, którego nazwa kończy się rozszerzeniem .gz, -gz, .z, -z lub _z (wielkość znaków bez znaczenia) i w nagłówku pliku znajduje się prawidłowa liczba (magic number) jest dekompresowany i zastępowany oryginalnym plikiem bez jednego z powyższych rozszerzeń. gunzip rozpoznaje też specjalne rozszerzenia nazw plików .tgz i .taz jako skróty dla, odpowiednio, .tar.gz i .tar.Z. Podczas kompresji pliku z rozszerzeniem .tar, jeżeli jest to konieczne, gzip używa rozszerzenia .tgz zamiast obcinania nazwy pliku.

gunzip może dokonać dekompresji plików stworzonych przez programy gzip, zip, compress, compress -H lub pack. Format pliku wejściowego jest rozpoznawany automatycznie. Podczas dekompresji plików w pierwszych dwóch formatach gunzip sprawdza 32-bitową sumę kontrolną CRC. W wypadku plików stworzonych przez programy pack i gunzip sprawdzana jest długość zdekompresowanego pliku. Standardowy format programu compress nie umożliwiał kontroli poprawności. Jednak niekiedy gunzip jest w stanie wykryć uszkodzony plik .Z. Jeżeli w trakcie dekompresji takiego pliku pojawią się błędy, nie należy sądzić, że plik jest w porządku, bo program uncompress nie zgłaszał problemów. Oznacza to tylko, że uncompress nie kontroluje poprawności plików wejściowych. Format plików compress -H systemu SCO (kompresja metodą LZH) również nie obsługuje kontroli poprawności, lecz także możliwe jest podstawowe sprawdzenie spójności pliku.

Pliki stworzone przez program zip mogą być zdekompresowane tylko, jeżeli w archiwum .zip znajduje się jeden plik i jest on skompresowany metodą „deflation”. Jest to opcja przeznaczona do konwersji plików .tar.zip do formatu .tar.gz. Aby zdekompresować plik .zip zawierający pojedynczy plik, można użyć poleceń gunzip < foo.zip czy gunzip -S .zip foo.zip. Do dekompresji archiwów .zip zawierających więcej niż jeden plik należy użyć programu unzip zamiast gunzip.

Polecenie zcat działa tak samo, jak gunzip -c (w niektórych systemach zcat może być zainstalowany jako gzcat, aby zachować oryginalne dowiązanie do programu compress). zcat dekompresuje pliki z listy podanej w linii poleceń lub pobiera dane ze standardowego wejścia, a następnie zapisuje zdekompresowane dane na standardowym wyjściu. zcat dokonuje dekompresji plików po sprawdzeniu, że w nagłówku pliku znajduje się właściwa liczba (magic number); nie jest wymagane, aby nazwa pliku miała rozszerzenie .gz.

Polecenie gzip korzysta z algorytmu Lempel-Ziv użytego w programach zip i PKZIP. Wydajność kompresji zależy od wielkości danych wejściowych oraz rozmieszczenia w danych jednakowych podciągów. Dane takie, jak kod źródłowy lub tekst w języku angielskim są zwykle redukowane o 60–70%. Osiągany stopień kompresji jest przeważnie dużo większy niż przy użyciu kodowania LZW (używanym przez program compress), Huffmana (pack) lub adaptywnym kodowaniu Huffmana (compact).

Kompresja jest przeprowadzana zawsze, nawet jeżeli plik wyjściowy jest większy niż oryginalny. W najgorszym przypadku narzut może wynosić kilka bajtów dla nagłówka i 5 bajtów dla każdego bloku o długości 32 KiB. Ewentualnie współczynnik powiększenia pliku może wynosić 0,015% dla bardzo dużych plików. Należy zauważyć, że prawie nigdy nie zwiększa się liczba bloków używanych przez plik na dysku.

gzip zwykle zachowuje tryb dostępu oraz czas modyfikacji pliku podczas kompresji i dekompresji. Jeśli ma się odpowiednie przywileje, zachowa również właściciela i grupę pliku.

OPCJE

-a --ascii
    Tryb tekstowy. Przekształca znaki końca linii, używając lokalnych konwencji. Ta opcja jest dostępna jedynie na kilku systemach nieuniksowych. W systemie MS-DOS podczas kompresji znaki CR LF są przekształcane na LF, a podczas dekompresji z powrotem.

-c --stdout --to-stdout
    Wypisuje skompresowane dane na standardowe wyjście; oryginalne pliki pozostają nienaruszone. Jeżeli podanych zostało kilka plików wejściowych, każdy z nich kompresowany jest oddzielnie. Dla osiągnięcia lepszej kompresji należy połączyć pliki ze sobą przed poddaniem ich kompresji.

-d --decompress --uncompress
    Dekompresuje plik.

-f --force
    Kompresuje plik nawet, jeżeli istnieją do niego twarde dowiązania lub plik wyjściowy już istnieje, lub też, jeżeli dane są uprzednio skompresowane. Jeżeli format danych wejściowych nie jest rozpoznany, a podana została opcja --stdout, dane zostają bez zmian przekopiowane na standardowe wyjście. zcat zachowuje się w takim wypadku jak cat. Jeżeli opcja -f nie została podana i program został uruchomiony w pierwszym planie, gzip pyta użytkownika przed nadpisaniem istniejącego pliku.

-h --help
    Wyświetla ekran pomocy i kończy działanie.

-k --keep
    Zachowuje (nie usuwa) pliki wejściowe przy kompresji lub dekompresji.

-l --list
    Dla każdego skompresowanego pliku wypisuje następujące informacje:

      compressed size: rozmiar skompresowanego pliku
      uncompressed size: rozmiar zdekompresowanego pliku
      ratio: współczynnik kompresji (0.0% jeżeli nieznany)
      uncompressed_name: nazwa zdekompresowanego pliku

    Rozmiar zdekompresowanego pliku jest wypisywany jako -1 dla plików nie będących w formacie gzip, jak na przykład pliki .Z. Aby poznać rozmiar takiego pliku po dekompresji, można użyć polecenia:

      zcat file.Z | wc -c

    Po podaniu również opcji --verbose dodatkowo są wyświetlane następujące informacje:

      method: metoda kompresji
      crc: 32-bitowa suma kontrolna CRC zdekompresowanych danych
      date & time: pole daty/czasu oryginalnego pliku

    Aktualnie dostępne metody kompresji to deflate, compress, lzh (SCO compress -H) oraz pack. Suma CRC dla plików w formacie innym niż gzip jest podawana jako ffffffff.

    Po podaniu opcji --name podawane są dane oryginalnego pliku zawarte w pliku skompresowanym (nazwa, data/czas), jeżeli zostaną tam znalezione.

    Po podaniu opcji --verbose wyświetlany jest wspólny rozmiar i współczynnik kompresji wszystkich plików, chyba że nie dla wszystkich plików te dane są dostępne. Po podaniu opcji --quiet linie nagłówka i podsumowania nie są wyświetlane.

-L --license
    Wyświetla informację o licencji i kończy działanie programu.

-n --no-name
    Podczas kompresji nie zachowuje w skompresowanym pliku oryginalnej nazwy, trybu dostępu oraz czasu modyfikacji i dostępu (oryginalna nazwa jest zapisywana, jeżeli nazwa pliku będzie musiała być obcięta). Podczas dekompresji nie odtwarza oryginalnej nazwy pliku (usuwa tylko rozszerzenie.gz z nazwy pliku), nie odtwarza również oryginalnego pola daty/czasu - zamiast tego pole to zostanie skopiowane ze skompresowanego pliku. Jest to domyślna opcja podczas dekompresji.

-N --name
    Podczas kompresji zawsze zachowuje oryginalną nazwę pliku oraz zachowuje sekundową część pierwotnego czasu modyfikacji, jeśli plik jest zwykłym plikiem, a jego znacznik czasu wynosi co najmniej 1 (1970-01-01 00:00:01 UTC) i mniej niż 2**32 (2106-02-07 06:28:16 UTC, zakładając, że nie są liczone sekundy przestępne); jest to zachowanie domyślne. Podczas dekompresji odtwarza z zapisanego pliku nazwę pliku, a także znacznik czasu, jeśli jest obecny. Ta opcja jest użyteczna na systemach z limitem długości nazwy pliku lub po utracie oryginalnego pola daty/czasu po transferze pliku.

-q --quiet
    Nie wyświetla żadnych ostrzeżeń.

-r --recursive
    Przechodzi rekurencyjnie zawartość katalogów. Jeśli którakolwiek z nazw plików podanych w linii poleceń odnosi się do katalogu, gzip przejdzie do tego katalogu i skompresuje wszystkie pliki, które w nim znajdzie (lub zdekompresuje w wypadku programu gunzip).

-S .suf --suffix .suf
    Przy kompresowaniu używa rozszerzenia .suf zamiast .gz. Można użyć dowolnego niepustego rozszerzenia, chociaż należy unikać innych niż .z lub .gz, aby uniknąć zamieszania po transferze plików do innego systemu.

    Przy dekompresowaniu dodaje .suf na początku listy rozszerzeń do wypróbowania, przy tworzeniu nazwy pliku wyjściowego z nazwy pliku wejściowego.

--synchronous
    Używa synchronicznego wyjścia. Korzystanie z tej opcji zmniejszy ryzyko utraty danych przez gzip w przypadku załamania systemu, lecz może go wyraźnie spowolnić.

-t --test
    Sprawdza spójność skompresowanego pliku i kończy działanie.

-v --verbose
    Wyświetla nazwę i procent kompresji każdego skompresowanego i nieskompresowanego pliku.

-V --version
    Wyświetla numer wersji oraz opcje kompilacji i kończy działanie.

-# --fast --best
    Określa prędkość kompresji za pomocą cyfry #, gdzie -1 lub --fast oznacza najszybszą (lecz najmniej wydajną) kompresję, zaś -9 lub --best oznacza najwolniejszą (lecz najbardziej wydajną) metodę kompresji. Domyślną wartością jest -6 (tzn. zorientowaną na lepszą kompresję kosztem prędkości).

--rsyncable
    Przy synchronizowaniu skompresowanego pliku pomiędzy dwoma komputerami, opcja ta pozwala programowi rsync na przesyłanie jedynie zmienionych plików z archiwów, zamiast całego archiwum. W zwykłej sytuacji, po zmianie dowolnego pliku w archiwum, algorytm kompresujący może utworzyć nową wersję archiwum, która jest odmienna od jego poprzedniej wersji. W takim przypadku konieczne jest przesłanie przez rsync całej nowej wersji archiwum na zdalny komputer. Dzięki tej opcji, rsync może przesłać jedynie zmienione pliki oraz niewielki zestaw metadanych, koniecznych do zaktualizowania struktury archiwum w zmienionym fragmencie.

ZAAWANSOWANE SPOSOBY UŻYCIA
Skompresowane pliki mogą być ze sobą łączone; w takim wypadku gunzip zdekompresuje wszystkie pliki jednocześnie. Na przykład:

      gzip -c plik1 > foo.gz
      gzip -c plik2 >> foo.gz

Następnie

      gunzip -c foo

jest równoznaczne z

      cat plik1 plik2

W wypadku, gdy jeden z połączonych plików zostanie uszkodzony, pozostałe wciąż mogą być odzyskane (po usunięciu uszkodzonego pliku). Jednak znacznie lepsze efekty daje jednoczesne kompresowanie wszystkich plików:

      cat plik1 plik2 | gzip > foo.gz

daje lepsze wyniki kompresji niż

      gzip -c plik1 plik2 > foo.gz

Aby ponownie skompresować połączone ze sobą pliki w celu uzyskania lepszej kompresji, należy wykonać polecenie:

      gzip -cd stary.gz | gzip > nowy.gz

Jeżeli skompresowny plik został utworzony z kilku plików, informacje o rozmiarze i sumie CRC uzyskane opcją --list dotyczą tylko ostatniego pliku. Informację o rozmiarze wszystkich plików po dekompresji można uzyskać przy pomocy polecenia:

      gzip -cd plik.gz | wc -c

Aby umieścić w archiwum kilka plików, a następnie mieć możliwość oddzielnego ich odzyskania, należy użyć programów takich jak tar lub zip. Tar w wersji GNU obsługuje opcję -z, która powoduje wywołanie programu gzip w sposób niewidzialny dla użytkownika. Gzip został zaprojektowany jako uzupełnienie programu tar; nie może go zastąpić.

ŚRODOWISKO
W przestarzałej zmiennej środowiskowej GZIP mogą się znajdować domyślne opcje dla programu gzip. Są one odczytywane na początku; w ten sposób opcje w linii poleceń mają przed nimi pierwszeństwo. Jako że powoduje to problemy przy korzystaniu ze skryptów, funkcja ta jest obsługiwana tylko w przypadku opcji, które nie powinny narobić zbyt wiele szkód; dodatkowo gzip wypisze odpowiednie ostrzeżenie. Funkcja ta będzie usunięta w kolejnym wydaniu gzip.

Jako zamiennika, można używać aliasu lub skryptu. Na przykład, jeśli gzip znajduje się w katalogu /usr/bin, można dodać $HOME/bin do swojej PATH i utworzyć wykonywalny skrypt $HOME/bin/gzip zawierający:

      #! /bin/sh
      export PATH=/usr/bin
      exec gzip -9 "$@"

ZOBACZ TAKŻE
znew(1), zcmp(1), zmore(1), zforce(1), gzexe(1), zip(1), unzip(1), compress(1)

Format pliku gzip jest opisany w: P. Deutsch, GZIP file format specification version 4.3, <https://www.ietf.org/rfc/rfc1952.txt>, Internet RFC 1952 (maj 1996). Format deflacji zipjest opisany w: P. Deutsch, DEFLATE Compressed Data Format Specification version 1.3, <https://www.ietf.org/rfc/rfc1951.txt>, Internet RFC 1951 (maj 1996).

DIAGNOSTYKA
Status zakończenia jest normalnie równy 0; jeżeli wystąpi błąd, status zakończenia jest równy 1. Jeżeli wystąpi ostrzeżenie, status zakończenia jest równy 2.

Usage: gzip [-cdfhklLnNrtvV19] [-S suffix] [file ...]
    W linii poleceń znalazły się nieprawidłowe opcje.

file: not in gzip format
    Podany plik nie jest skompresowany (komunikat programu gunzip).

file: Corrupt input.
    Należy skorzystać z zcat, do odzyskania części danych. Skompresowany plik uległ uszkodzeniu. Do miejsca uszkodzenia dane mogą być odzyskane poleceniem

        zcat file > recover

file: compressed with xx bits, can only handle yy bits
    File został skompresowany (z użyciem algorytmu LZW) przez program obsługujący kody o większej ilości bitów niż program do dekompresji na tym komputerze. Należy skompresować plik od nowa programem gzip, który osiąga lepszy współczynnik kompresji i używa mniej pamięci.

file: already has .gz suffix -- no change
    Plik z rozszerzeniem nazwy .gz nie może być ponownie kompresowany. Zmień nazwę pliku i spróbuj ponownie.

file already exists; do you wish to overwrite (y or n)?
    Należy odpowiedzieć „y”, by nadpisać istniejący już plik wyjściowy lub „n” w przeciwnym przypadku.

gunzip: corrupt input
    Program otrzymał sygnał SIGSEGV, co zazwyczaj oznacza, że plik wejściowy jest uszkodzony.

xx.x% Percentage of the input saved by compression.
    (Tylko po podaniu opcji -v i -l).

-- not a regular file or directory: ignored
    Gdy plik wejściowy nie jest zwykłym plikiem lub katalogiem (tzn. jest np. dowiązaniem symbolicznym, gniazdem, kolejką FIFO, plikiem urządzenia), jest pozostawiany bez zmian.

-- has xx other links: unchanged
    Plik wejściowy ma twarde dowiązania i nie może zostać zmieniony. Więcej informacji można znaleźć w opisie polecenia ln(1). Użycie opcji -f wymusi kompresję plików mających twarde dowiązania.

OSTRZEŻENIA
Podczas zapisywania danych na taśmie zazwyczaj trzeba dodać na końcu odpowiednią liczbę zer, by ostatnia część danych zajmowała pełny blok. Gdy dane są odczytywane przez program gunzip, wykrywa on, że na końcu właściwych danych znajdują się dodatkowo przypadkowe dane i wypisuje ostrzeżenie. Aby tego uniknąć, należy używać opcji --quiet.

USTERKI
Niekiedy (rzadko) zdarza się, że kompresja z opcją --best daje gorsze rezultaty niż z opcją domyślną (-6). Niektóre pliki, w których powtarza się bardzo dużo sekwencji, są lepiej kompresowane programem compress niż gzip.

ZGŁASZANIE BŁĘDÓW
Raporty o błędach można wysyłać do <bug-gzip@gnu.org>.
Strona internetowa GNU gzip: <https://www.gnu.org/software/gzip/>
Ogólna pomoc dotycząca oprogramowania GNU: <https://www.gnu.org/gethelp/>

PRAWA AUTORSKIE
Copyright © 1998–1999, 2001–2002, 2012, 2015–2023 Free Software Foundation, Inc.
Copyright © 1992, 1993 Jean-loup Gailly

Permission is granted to make and distribute verbatim copies of this manual provided the copyright notice and this permission notice are preserved on all copies.

Permission is granted to copy and distribute modified versions of this manual under the conditions for verbatim copying, provided that the entire resulting derived work is distributed under the terms of a permission notice identical to this one.

Permission is granted to copy and distribute translations of this manual into another language, under the above conditions for modified versions, except that this permission notice may be stated in a translation approved by the Foundation.

TŁUMACZENIE
Autorami polskiego tłumaczenia niniejszej strony podręcznika są: Łukasz Kowalczyk <lukow@tempac.okwf.fuw.edu.pl>, Michał Górny <zrchos+manpagespl@gmail.com> i Michał Kułach <michal.kulach@gmail.com>

Niniejsze tłumaczenie jest wolną dokumentacją. Bliższe informacje o warunkach licencji można uzyskać zapoznając się z GNU General Public License w wersji 3 (https://www.gnu.org/licenses/gpl-3.0.html) lub nowszej. Nie przyjmuje się ŻADNEJ ODPOWIEDZIALNOŚCI.

Błędy w tłumaczeniu strony podręcznika prosimy zgłaszać na adres listy dyskusyjnej manpages-pl-list@lists.sourceforge.net.